routes/web.php
<?php

use App\Http\Controllers\DashboardController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PengumumanController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\ProductCategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\SettingController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    return redirect()->route('login');
});

Route::middleware(['auth', 'permission'])->group(function () {
    Route::group(['prefix' => 'dashboard', 'as' => 'dashboard.'], function () {
        Route::get('/', [DashboardController::class, 'index'])->name('index');
    });

    Route::group(['prefix' => 'blank', 'as' => 'blank.'], function () {
        Route::get('/', function () {
            return view('sample.blank.index');
        })->name('index');
    });

    Route::group(['prefix' => 'product', 'as' => 'product.'], function () {
        Route::get('/', [ProductController::class, 'index'])->name('index');
        Route::get('/create', [ProductController::class, 'create'])->name('create');
        Route::post('/store', [ProductController::class, 'store'])->name('store');
        Route::get('/edit/{product}', [ProductController::class, 'edit'])->name('edit');
        Route::patch('/update/{product}', [ProductController::class, 'update'])->name('update');
        Route::delete('/destroy/{product}', [ProductController::class, 'destroy'])->name('destroy');
    });

    Route::group(['prefix' => 'product-category', 'as' => 'product-category.'], function () {
        Route::get('/', [ProductCategoryController::class, 'index'])->name('index');
        Route::get('/create', [ProductCategoryController::class, 'create'])->name('create');
        Route::post('/store', [ProductCategoryController::class, 'store'])->name('store');
        Route::get('/edit/{product_category}', [ProductCategoryController::class, 'edit'])->name('edit');
        Route::patch('/update/{product_category}', [ProductCategoryController::class, 'update'])->name('update');
        Route::delete('/destroy/{product_category}', [ProductCategoryController::class, 'destroy'])->name('destroy');
    });
    
    Route::group(['prefix' => 'setting', 'as' => 'setting.'], function () {
        Route::group(['prefix' => 'profile', 'as' => 'profile.'], function () {
            Route::get('/', [ProfileController::class, 'index'])->name('index');
            Route::patch('update', [ProfileController::class, 'update'])->name('update');
        });

        Route::group(['prefix' => 'permission', 'as' => 'permission.'], function () {
            Route::get('/', [PermissionController::class, 'index'])->name('index');
            Route::patch('update/{permission}', [PermissionController::class, 'update'])->name('update');
            Route::post('assign-revoke', [PermissionController::class, 'assignRevoke'])->name('assign_revoke');
            Route::get('refresh', [PermissionController::class, 'refresh'])->name('refresh');
            Route::get('refresh-and-assign', [PermissionController::class, 'refreshAndAssign'])->name('refresh_and_assign');
            Route::delete('destroy/{permission}', [PermissionController::class, 'destroy'])->name('destroy');
        });

        Route::group(['prefix' => 'role', 'as' => 'role.'], function () {
            Route::get('/', [RoleController::class, 'index'])->name('index');
            Route::post('store', [RoleController::class, 'store'])->name('store');
            Route::patch('update/{role}', [RoleController::class, 'update'])->name('update');
            Route::delete('destroy/{role}', [RoleController::class, 'destroy'])->name('destroy');
        });
    });

});

app/Models/Role.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Spatie\Permission\Models\Role as SpatieRole;

class Role extends SpatieRole
{
    use HasFactory;

    protected $fillable = [
        'name',
        'guard_name'
    ];
}

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use App\DataTables\RoleDataTable;
use Illuminate\Http\Request;

class RoleController extends Controller
{
    public function index(RoleDataTable $roleDataTable)
    {
        $include_page = 'setting.role.datatable';
        $page_title = 'Role';

        $data = [
            'include_page' => $include_page,
            'page_title' => $page_title,
        ];
        return $roleDataTable->render('setting.index', $data);
    }
}

app/Http/Controllers/SettingController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class SettingController extends Controller
{
    //
}

resources/views/setting/role/datatable.blade.php
@push('styles')
    <link rel="stylesheet" type="text/css" href="{{ asset('plugin/datatables/datatables.min.css') }}" />
@endpush

<div class="card">
    <div class="card-header text-right mb-0 pb-0">
        <a href="#" class="btn btn-primary"><i class="fas fa-folder-plus"></i> Create New</a>
    </div>
    
    <div class="card-body">
        {!! $dataTable->table(['width' => '100%']) !!}
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="permissionModal" tabindex="-1" aria-labelledby="permissionModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="permissionModalLabel">Edit Permission</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                {!! Form::hidden('id', null, ['id' => 'permissionId']) !!}
                {!! Form::label('permissionAlias', 'Alias', []) !!}
                {!! Form::text('alias', null, ['class' => 'form-control', 'id' => 'permissionAlias']) !!}
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                <button type="button" id="btnUpdatePermission" onclick="updatePermission(this)" data-url=""
                    class="btn btn-primary">Update</button>
            </div>
        </div>
    </div>
</div>

@push('scripts')
    <script type="text/javascript" src="{{ asset('plugin/datatables/datatables.min.js') }}"></script>
    {!! $dataTable->scripts() !!}
@endpush

resources/views/setting/role/datatable_actions.blade.php
<div class="form-group">
    <a href="#" class="btn btn-warning" data-bs-toggle="modal" data-bs-target="#roleModal" onclick="editRole(this)" data-id="{{ $id }}" data-url="{{ route('setting.role.update', $id) }}" data-bs-placement="bottom" title="Edit" ><i class="menu-icon fa fa-pencil-alt"></i></a>
    <a href="#" onclick="deleteModel('{{ route('setting.role.destroy', $id) }}', 'roleDatatable', 'role', 'user with role {{ $name }} will unable to login again')" class="btn btn-danger" data-bs-toggle="tooltip" data-bs-placement="bottom" title="Hapus"><i class="menu-icon fa fa-trash"></i></a>
</div>